// subpages/goodsorder/goodsorder.js
var app = getApp();
Page({

    /**
     * 页面的初始数据
     */
    data: {
        tabList: [{
            name: "全部",
            type: "all"
        }, {
            name: "代付款",
            type: "0"
        }, {
            name: "待收货",
            type: "2"
        }, {
            name: "已完成",
            type: "4"
        }, {
            name: "已取消",
            type: ""
        }, ],
        dataList: [],
        currentIndex: 0,
        pages: {
            page: 1,
            rows: 3,
            isCancel: '',
            orderStatus: ''
        },
        token: '',
        isHideLoading: false,
        imgUrl: app.shopImgUrl,
        cancelList: [],
        currentCancel: {},
        isShowCancel: false,
        cancelRemark: "",
        totalSize: 0,
        isShowLoading: true,
        loading: "加载中"
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        var _self = this;
        _self.getToken().then(res => {
            _self.getGoodsList();
        });
    },
    changeTab(e) {
        var _self = this;
        var type = e.currentTarget.dataset.type
        var isCancel = type == '' ? '1' : '0';
        if (isCancel == '1') {
            type = '';
        }
        if ('all' == type) {
            type = '';
            isCancel = '';
        }
        var tempPage = {
            page: 1,
            isCancel: isCancel,
            orderStatus: type
        }
        _self.setData({
            currentIndex: e.currentTarget.dataset.index,
            pages: tempPage,
            dataList: []
        })
        _self.getGoodsList();
    },
    getGoodsList() {
        var _self = this;
        _self.setData({
            isHideLoading: !(1 == _self.data.pages.page)
        })
        app.restAjax.get(app.restAjax.path(app.shopUrl + '/app/order/listpage', []),
            _self.data.pages, {
                headers: {
                    token: _self.data.token
                }
            },
            function (code, data) {
                _self.setData({
                    isHideLoading: true
                })
                if ('200' == code) {
                    if (1 === _self.data.pages.page) {
                        _self.setData({
                            dataList: data.rows,
                            totalSize: data.total
                        })
                    } else {
                        _self.setData({
                            dataList: _self.data.dataList.concat(data.rows)
                        })
                        console.log(_self.data.dataList.length)
                        if (_self.data.dataList.length >= _self.data.totalSize) {
                            _self.setData({
                                isShowLoading: false,
                                loading: "没有更多数据了"
                            })
                        }

                    }
                }
            },
            function () {
                _self.setData({
                    isHideLoading: true
                })
            },
            function () {
                _self.setData({
                    isHideLoading: true
                })
                wx.hideNavigationBarLoading(); //完成停止加载图标
                wx.stopPullDownRefresh();
                wx.hideLoading();
            })
    },
    getToken: function () {
        var self = this;
        return new Promise(resolve => {
            wx.getStorage({
                key: 'token',
                success(res) {
                    self.setData({
                        token: res.data
                    })
                    return resolve();
                }
            })
        })
    },
    // 支付
    toPayOrder(e) {
        var item = e.currentTarget.dataset.item;
        wx.showToast({
            icon: "none",
            title: '暂时无法支付',
        })
    },
    //取消订单
    toCancelOrder(e) {
        var _self = this;
        var item = e.currentTarget.dataset.item; //当前订单
        app.dialog.loading("加载中...");
        app.restAjax.get(app.restAjax.path('{shopUrl}/app/data/listbyparentid/{id}',
                [app.shopUrl, "bf2d6bb5-4562-4ace-827e-378e41571576"]), {}, {
                headers: {
                    token: _self.data.token
                }
            },
            function (code, data) {
                wx.hideLoading()
                if (data && data.length > 0) {
                    for (let i = 0; i < data.length; i++) {
                        if (i == 0) {
                            data[i].check = true;
                        } else {
                            data[i].check = false;
                        }
                    }
                    _self.setData({
                        cancelList: data,
                        currentCancel: data[0],
                        isShowCancel: true,
                        curOrder: item
                    })
                } else {
                    app.dialog.msg("暂时无法取消订单")
                }
            },
            function (code, data) {
                app.dialog.msg(data.msg);
            },
            function () {
                wx.hideLoading();
            })
    },
    //删除订单
    toDelOrder(e) {
        var _self = this;
        var item = e.currentTarget.dataset.item;
        wx.showModal({
            title: '提示',
            content: '确定要删除该订单吗?删除后将无法找回.',
            complete: (res) => {
                if (res.confirm) {
                    app.restAjax.delete(app.restAjax.path('{shopUrl}/app/order/delete/{orderId}',
                            [app.shopUrl, item.orderId]), {}, {
                            headers: {
                                token: _self.data.token
                            }
                        },
                        function (code, data) {
                            if (code == '200') {
                                app.dialog.msg('删除成功')
                            }
                            wx.startPullDownRefresh()
                        },
                        function (code, data) {
                            app.dialog.msg(data.msg);
                        },
                        function () {
                            wx.hideLoading();
                        })
                }
            }
        })
    },
    inputRemark(e) {
        console.log(e)
        this.setData({
            cancelRemark: e.detail.value
        })
    },
    //选择取消
    chooseCancel(e) {
        var item = e.currentTarget.dataset.item;
        var index = e.currentTarget.dataset.index;
        item.check = true;
        var _self = this;
        _self.data.cancelList.forEach((item, i) => {
            if (i == index) {
                item.check = true;
            } else {
                item.check = false;
            }
        });
        _self.setData({
            currentCancel: item,
            cancelList: _self.data.cancelList
        })
    },
    cancelDialog() {
        this.setData({
            isShowCancel: false
        })
    },
    confirmCancel() {
        var _self = this;
        _self.setData({
            isShowCancel: false
        })
        var cancelBean = {
            cancelData: _self.data.currentCancel.dataId,
            cancelRemark: _self.data.cancelRemark,
        };
        app.dialog.loading("取消中...");
        app.restAjax.put(app.restAjax.path('{shopUrl}/app/order/updatebuyersclose/{orderId}',
                [app.shopUrl, _self.data.curOrder.orderId]), cancelBean, {
                headers: {
                    token: _self.data.token
                }
            },
            function (code, data) {
                if (code == '200') {
                    wx.startPullDownRefresh()
                    app.dialog.msg('取消成功')
                }
            },
            function (code, data) {
                app.dialog.msg(data.msg);
            },
            function () {
                wx.hideLoading();
            })
    },
    onPullDownRefresh: function () {
        // 在标题栏中显示加载图标
        var _self = this;
        _self.setData({
            [`pages.page`]: 1,
            dataList: []
        })
        _self.getGoodsList()
    },
    onReachBottom() {
        var _self = this;
        if (_self.data.totalSize > _self.data.dataList.length) {
            _self.setData({
                [`pages.page`]: _self.data.pages.page + 1,
            })
            _self.getGoodsList();
        }
    }
})